//
//  ViewController.m
//  130499
//
//  Created by IGUser on 1/24/14.
//  Copyright (c) 2014 MMAcademy. All rights reserved.
//

#import "ViewController.h"

static int boundary = 950;
static int totalPoints = 200;
static int currentPoint = 0;


@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    pointsArray = [[NSMutableArray alloc] init];
    
    [self initSwarm];
    
    infraChart = [[IGChartView alloc] init];
    infraChart.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height - 250);
    infraChart.frame = CGRectInset(infraChart.frame, 10, 10);
    infraChart.autoresizingMask = UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth;
   
    

    
    sourceData = [[IGScatterSeriesDataSourceHelper alloc] initWithData:pointsArray xPath:@"x" andYPath:@"y"];
    dataSeries = (IGScatterSplineSeries *)[infraChart addSeriesForType:[IGScatterSplineSeries class] usingKey:@"scatterFlock" withDataSource:sourceData firstAxisKey:@"xAxisFlock" secondAxisKey:@"yAxisFlock"];
    dataSeries.transitionDuration = 0.95;

    dataSeries.xAxis.minimum = 0;
    dataSeries.xAxis.maximum = boundary + 50;
    dataSeries.yAxis.minimum = -(boundary + 50);
    dataSeries.yAxis.maximum = boundary + 50;
    dataSeries.xAxis.majorStroke = [[IGBrush alloc] initWithColor:[UIColor clearColor]];
    dataSeries.yAxis.majorStroke = [[IGBrush alloc] initWithColor:[UIColor clearColor]];

    
    rangeSelectorView = [[IGRangeSelectorView alloc]init];
    rangeSelectorView.frame = CGRectMake(0, self.view.frame.size.height - 255, self.view.frame.size.width, 245);
    rangeSelectorView.autoresizingMask = UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleTopMargin;
    [self.view addSubview:rangeSelectorView];
    chartViewSelector = [[IGChartView alloc] init];
    [chartViewSelector setAutoresizingMask:UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight];
    
    IGScatterSplineSeries *areaSeries1 = (IGScatterSplineSeries *) [chartViewSelector addSeriesForType:[IGScatterSplineSeries class] usingKey:@"areaSeries" withDataSource:sourceData firstAxisKey:@"x" secondAxisKey:@"y"];
    areaSeries1.transitionDuration = 0.91;
    areaSeries1.xAxis.labelsVisible = NO;
    areaSeries1.yAxis.labelsVisible = NO;
    rangeSelectorView.contentView = chartViewSelector;
    infraChart.zoomDisplayType = IGChartZoomHorizontal;
    infraChart.zoombar = rangeSelectorView;
    
    
    [self.view addSubview:infraChart];
    timer = [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(timerTick) userInfo:nil repeats:YES];
}
-(void)timerTick
{
    /*int counter = 0;
        for (int i =0; i < pointsArray.count -1 ; i++)
    {
        DataPoint *point = [pointsArray objectAtIndex:i ];
        int index = (i+1);//%(pointsArray.count);
        DataPoint *newPoint = [pointsArray objectAtIndex:index];
        point.y = newPoint.y;
        [infraChart updateItemAtIndex:i withSource:sourceData];
        [chartViewSelector updateItemAtIndex:i withSource:sourceData];
        
        counter++;
    }
    //add new point
    DataPoint *newPoint = [pointsArray objectAtIndex:pointsArray.count -1];
    newPoint.y = sinf(currentPoint*950)*300;
    [infraChart updateItemAtIndex:(pointsArray.count -1) withSource:sourceData];
    [chartViewSelector updateItemAtIndex:(pointsArray.count -1) withSource:sourceData];
    currentPoint++;*/
    int counter = 0;
    [infraChart removeItemAtIndex:0 withSource:sourceData];
    [chartViewSelector removeItemAtIndex:0 withSource:sourceData];
    for (int i =0; i < pointsArray.count -1 ; i++)
    {
        DataPoint *point = [pointsArray objectAtIndex:i ];
        int index = (i+1);//%(pointsArray.count);
        DataPoint *newPoint = [pointsArray objectAtIndex:index];
        point.y = newPoint.y;
        [infraChart updateItemAtIndex:i withSource:sourceData];
        [chartViewSelector updateItemAtIndex:i withSource:sourceData];
        
        counter++;
    }
    //add new point
    DataPoint *newPoint = [pointsArray objectAtIndex:pointsArray.count -1];
    newPoint.y = sinf(currentPoint*950)*300;
    [infraChart insertItemAtIndex:(pointsArray.count -1) withSource:sourceData];
    //[infraChart updateItemAtIndex:(pointsArray.count -1) withSource:sourceData];
    [chartViewSelector insertItemAtIndex:(pointsArray.count -1) withSource:sourceData];
    currentPoint++;

    
}

-(void)initSwarm
{
    for (int i = 0; i < totalPoints; i++)
    {
        DataPoint *point = [[DataPoint alloc]init];

        point.x = (currentPoint * 8);
        point.y = sinf(currentPoint*950)*300;
        currentPoint++;
        [pointsArray addObject:point];
        
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end

@implementation DataPoint
@synthesize x,y;
@end


